#include "Core/CFObject.h"
#include <gtkmm.h>
#include "PrivDefines.h"

CF_NAMESPACE_BEGIN

std::map<void*, CFObject*> CFObject::s_objMap;

CFObject::CFObject()
    : m_realObj(NULL) {

}

CFObject::~CFObject() {
}

void* CFObject::getObj() {
    return m_realObj;
}

CFObject* CFObject::getCFObject(void* realObj) {
    if (s_objMap.end() != s_objMap.find(realObj)) {
        return s_objMap[realObj];
    }
    return NULL;
}

void CFObject::setRealObject(void* obj) {
    if (NULL != m_realObj) {
        onRealObjectFinalize();
        Gtk::Object* realObj = static_cast<Gtk::Object*>(m_realObj);
        s_objMap.erase((void*)realObj);
        delete realObj;
        m_realObj = NULL;
    }
    m_realObj = obj;
    if (NULL != m_realObj) {
        Gtk::Object* realObj = static_cast<Gtk::Object*>(m_realObj);
        s_objMap.insert(std::pair<void*, CFObject*>((void*)realObj, this));
        onRealObjectInit();
    }
}

void CFObject::onRealObjectInit() {

}

void CFObject::onRealObjectFinalize() {
}

CF_NAMESPACE_END