﻿#include <limits>
#include <Core/CFTimer.h>

CFTimer::CFTimer() {
	m_time = std::clock();
}

CFTimer::~CFTimer() {
	/*do not need nothing*/
}

void CFTimer::restart() {
	m_time = std::clock();
}

double CFTimer::elapsed() const {
	return double(std::clock() - m_time) / CLOCKS_PER_SEC;
}

double CFTimer::elapsedMax() const {
	return (double((std::numeric_limits<std::clock_t>::max)()) - double(m_time)) / double(CLOCKS_PER_SEC);
}

double CFTimer::elapsedMin() const {
	return double(1)/double(CLOCKS_PER_SEC);
}


