#include "Gui/CFBox.h"
#include <gtkmm.h>
#include "CFConvertor.h"

CF_NAMESPACE_BEGIN

CFBox::CFBox(CFOrientation orientation, int spacing) {
    setRealObject(new Gtk::Box(toGtkOrientation(orientation), spacing));
}

CFBox::~CFBox() {
    setRealObject(NULL);
}

void CFBox::packStart(CFWidget& child, bool expand, bool fill, CFUInt padding) {
    Gtk::Box* obj = static_cast<Gtk::Box*>(getObj());
    Gtk::Widget* wgd = static_cast<Gtk::Widget*>(child.getObj());
    if (NULL != obj && NULL != wgd) {
        obj->pack_start(*wgd, expand, fill, padding);
    }
}

void CFBox::packEnd(CFWidget& child, bool expand, bool fill, CFUInt padding) {
    Gtk::Box* obj = static_cast<Gtk::Box*>(getObj());
    Gtk::Widget* wgd = static_cast<Gtk::Widget*>(child.getObj());
    if (NULL != obj && NULL != wgd) {
        obj->pack_end(*wgd, expand, fill, padding);
    }
}

CF_NAMESPACE_END
