  #include "Gui/CFEventBox.h"
#include <gtkmm.h>

CF_NAMESPACE_BEGIN

CFEventBox::CFEventBox()
    : CFBin() {
        
    setRealObject(new Gtk::EventBox());
}

CFEventBox::~CFEventBox() {
    setRealObject(NULL);
}

bool CFEventBox::getVisibleWindow() {
    Gtk::EventBox* obj = static_cast<Gtk::EventBox*>(getObj());
    if (NULL != obj) {
        return obj->get_visible_window(); 
    }
    return false;
}

void CFEventBox::setVisibleWindow(bool visible_window) {
    Gtk::EventBox* obj = static_cast<Gtk::EventBox*>(getObj());
    if (NULL != obj) {
        obj->set_visible_window(visible_window);
    }
}

bool CFEventBox::getAboveChild() {
    Gtk::EventBox* obj = static_cast<Gtk::EventBox*>(getObj());
    if (NULL != obj) {
        return obj->get_above_child();
    }
    return false;
}

void CFEventBox::setAboveChild(bool above_child) {
    Gtk::EventBox* obj = static_cast<Gtk::EventBox*>(getObj());
    if (NULL != obj) {
        obj->set_above_child(above_child);
    }
}

CF_NAMESPACE_END
