// Copyright 2017, CDOS.
// All rights reserved.
//
// Author: CDOS Support Team <support_os@sari.ac.cn>
//
// A container which allows you to position widgets at fixed coordinates.

#include "Gui/CFFixed.h"
#include <gtkmm.h>
#include <exception>
#include <iostream>

CF_NAMESPACE_BEGIN

CFFixed::CFFixed() {
    setRealObject(new Gtk::Fixed());
}

CFFixed::~CFFixed() {
    setRealObject(NULL);
}

void CFFixed::put(CFWidget& widget, int x, int y) {
    try {
        Gtk::Widget* obj = static_cast<Gtk::Widget*>(widget.getObj());
        Gtk::Fixed* fixed = static_cast<Gtk::Fixed*>(getObj());
        if (fixed == NULL) {
            std::string error_msg = "occur error, argument error.";
            throw std::invalid_argument(error_msg);
        }
        fixed->put(*obj, x, y);
    } catch (const std::exception& e) {
        std::cout << e.what() << std::endl;
    }
}

void CFFixed::move(CFWidget& widget, int x, int y) {
    try {
        Gtk::Widget* obj = static_cast<Gtk::Widget*>(widget.getObj());
        Gtk::Fixed* fixed = static_cast<Gtk::Fixed*>(getObj());
        if (fixed == NULL) {
            std::string error_msg = "occur error, argument error.";
            throw std::invalid_argument(error_msg);
        }
        fixed->move(*obj, x, y);
    } catch (const std::exception& e) {
        std::cout << e.what() << std::endl;
    }
}

CF_NAMESPACE_END
