#include "Gui/CFImage.h"
#include <gtkmm.h>
#include "PrivCommon/CFConvertor.h"

CF_NAMESPACE_BEGIN

CFImage::CFImage()
    : CFMisc() {
    setRealObject(new Gtk::Image());
}

CFImage::CFImage(const std::string& file)
    : CFMisc() {
    setRealObject(new Gtk::Image(file));
}

CFImage::CFImage(const Glib::RefPtr< Gdk::Pixbuf>& pixbuf)
    : CFMisc() {
    setRealObject(new Gtk::Image(pixbuf));
}

CFImage::~CFImage() {
    setRealObject(NULL);
}

void CFImage::set(const std::string& filename) {
    Gtk::Image* obj = static_cast<Gtk::Image*>(getObj());
    if (NULL != obj) {
        obj->set(filename);
    }
}

void CFImage::set(const Glib::RefPtr< Gdk::Pixbuf>& pixbuf) {
    Gtk::Image* obj = static_cast<Gtk::Image*>(getObj());
    if (NULL != obj) {
        obj->set(pixbuf);
    }
}

void CFImage::setFromIconName(const Glib::ustring& icon_name,
                                                    CFBuiltinIconSize icon_size) {
    Gtk::Image* obj = static_cast<Gtk::Image*>(getObj());
    if (NULL != obj) {
        Gtk::BuiltinIconSize iconSize = toGtkBuiltinIconSize(icon_size);
        obj->set_from_icon_name(icon_name, iconSize);
    }
}

CF_NAMESPACE_END
