// Copyright 2017, CDOS.
// All rights reserved.
//
// Author: CDOS Support Team <support_os@sari.ac.cn>
//
// As item add in CFListWidget.
#include "Gui/CFListWidgetItem.h"
#include <gtkmm.h>

CF_NAMESPACE_BEGIN

CFListWidgetItem::CFListWidgetItem() {
    setRealObject(new Gtk::ListBoxRow());
}

CFListWidgetItem::~CFListWidgetItem() {
    setRealObject(NULL);
}

void CFListWidgetItem::setHeader(CFWidget& header) {
    Gtk::Widget* wobj = static_cast<Gtk::Widget*>(header.getObj());
    Gtk::ListBoxRow* obj = static_cast<Gtk::ListBoxRow*>(getObj());
    if (NULL != obj) {
        obj->set_header(*wobj);
    }
    return;
}

void CFListWidgetItem::unsetHeader() {
    Gtk::ListBoxRow* obj = static_cast<Gtk::ListBoxRow*>(getObj());
    if (NULL != obj) {
        obj->unset_header();
    }
    return;
}

CFWidget* CFListWidgetItem::getHeader() {
    Gtk::ListBoxRow* obj = static_cast<Gtk::ListBoxRow*>(getObj());
    if (NULL != obj) {
        Gtk::Widget* wobj = obj->get_header();
        CFWidget* cobj = static_cast<CFWidget*>(getCFObject(wobj));
        return cobj;
    }
    return NULL;
}

int CFListWidgetItem::getIndex() {
    int index = -1;
    Gtk::ListBoxRow* obj = static_cast<Gtk::ListBoxRow*>(getObj());
    if (NULL != obj) {
        index = obj->get_index();
    }
    return index;
}

void CFListWidgetItem::changed() {
    Gtk::ListBoxRow* obj = static_cast<Gtk::ListBoxRow*>(getObj());
    if (NULL != obj) {
        obj->changed();
    }
    return;
}

bool CFListWidgetItem::isSelected() {
    bool res = false;
    Gtk::ListBoxRow* obj = static_cast<Gtk::ListBoxRow*>(getObj());
    if (NULL != obj) {
        res = obj->is_selected();
    }
    return res;
}

void CFListWidgetItem::setSelectable(bool selectable) {
    Gtk::ListBoxRow* obj = static_cast<Gtk::ListBoxRow*>(getObj());
    if (NULL != obj) {
        obj->set_selectable(selectable);
    }
    return;
}

bool CFListWidgetItem::getSelectable() {
    bool res = false;
    Gtk::ListBoxRow* obj = static_cast<Gtk::ListBoxRow*>(getObj());
    if (NULL != obj) {
        res = obj->get_selectable();
    }
    return res;
}

void CFListWidgetItem::setActivatable(bool activatable) {
    Gtk::ListBoxRow* obj = static_cast<Gtk::ListBoxRow*>(getObj());
    if (NULL != obj) {
        obj->set_activatable(activatable);
    }
    return;
}

bool CFListWidgetItem::getActivatable() {
    bool res = false;
    Gtk::ListBoxRow* obj = static_cast<Gtk::ListBoxRow*>(getObj());
    if (NULL != obj) {
        res = obj->get_activatable();
    }
    return res;
}

CF_NAMESPACE_END
