#include "Gui/CFMain.h"
#include <gtkmm.h>

CF_NAMESPACE_BEGIN

CFMain::CFMain(int& argc, char**& argv, Glib::OptionContext& option_context)
    : CFObject() {
    setRealObject(new Gtk::Main(argc, argv, option_context));
}

CFMain::CFMain(int* argc, char*** argv, bool set_locale)
    : CFObject() {
    setRealObject(new Gtk::Main(argc, argv, set_locale));
}

CFMain::CFMain(int& argc, char**& argv, bool set_locale)
    : CFObject() {
    setRealObject(new Gtk::Main(argc, argv, set_locale));
}

CFMain::CFMain(bool set_locale) {
    setRealObject(new Gtk::Main(set_locale));
}

CFMain::~CFMain() {
    setRealObject(NULL);
}

void CFMain::run() {
    Gtk::Main::run();
}

void CFMain::run(CFWindow& window) {
    Gtk::Window* wd = static_cast<Gtk::Window*>(window.getObj());
    if (NULL != wd) {
        Gtk::Main::run(*wd);
    } else {
        CFMain::run();
    }
}

void CFMain::quit() {
    Gtk::Main::quit();
}

void CFMain::addGtkOptionGroup(Glib::OptionContext& option_context,
                               bool open_default_display) {
    Gtk::Main::add_gtk_option_group(option_context, open_default_display);
}

CF_NAMESPACE_END
