// Copyright 2017, CDOS.
// All rights reserved.
//
// Author: CDOS Support Team <support_os@sari.ac.cn>
//
// A standard menu bar which usually holds CFMenu submenu items.
#include "Gui/CFMenuBar.h"
#include <gtkmm.h>
#include "PrivCommon/CFConvertor.h"

CF_NAMESPACE_BEGIN

CFMenuBar::CFMenuBar() {
    setRealObject(new Gtk::MenuBar());
}

CFMenuBar::~CFMenuBar() {
    setRealObject(NULL);
}

CFPackDirection CFMenuBar::getPackDirection() {
    Gtk::MenuBar* obj = static_cast<Gtk::MenuBar*>(getObj());
    if (NULL != obj) {
        Gtk::PackDirection dir = obj->get_pack_direction();
        CFPackDirection cf_dir = toCdosPackDirection(dir);
        return cf_dir;
    }
    return CFPACK_DIRECTION_LTR;
}

void CFMenuBar::setPackDirection(CFPackDirection pack_dir) {
    Gtk::MenuBar* obj = static_cast<Gtk::MenuBar*>(getObj());
    if (NULL != obj) {
        Gtk::PackDirection dir = toGtkPackDirection(pack_dir);
        obj->set_pack_direction(dir);
    }
    return;
}

CFPackDirection CFMenuBar::getChildPackPirection() {
    Gtk::MenuBar* obj = static_cast<Gtk::MenuBar*>(getObj());
    if (NULL != obj) {
        Gtk::PackDirection dir = obj->get_child_pack_direction();
        CFPackDirection cf_dir = toCdosPackDirection(dir);
        return cf_dir;
    }
    return CFPACK_DIRECTION_LTR;
}

void CFMenuBar::setChildPackPirection(CFPackDirection pack_dir) {
    Gtk::MenuBar* obj = static_cast<Gtk::MenuBar*>(getObj());
    if (NULL != obj) {
        Gtk::PackDirection dir = toGtkPackDirection(pack_dir);
        obj->set_child_pack_direction(dir);
    }
    return;
}

CF_NAMESPACE_END
