#include "Gui/CFPopover.h"
#include <gtkmm.h>
#include "CFConvertor.h"

CF_NAMESPACE_BEGIN

CFPopover::CFPopover()
    : CFBin() {
    setRealObject(new Gtk::Popover());
}

CFPopover::CFPopover(CFWidget& relative_to)
    : CFBin() {
    setRealObject(new Gtk::Popover());
    setRelativeTo(relative_to);
}

CFPopover::~CFPopover() {

}

void CFPopover::setRelativeTo(CFWidget& relative_to) {
    Gtk::Popover* obj = static_cast<Gtk::Popover*>(getObj());
    Gtk::Widget* wobj = static_cast<Gtk::Widget*>(relative_to.getObj());
    if (NULL != obj && NULL != wobj) {
        obj->set_relative_to(*wobj);
    }
}

void CFPopover::setPosition(CFPositionType position) {
    Gtk::Popover* obj = static_cast<Gtk::Popover*>(getObj());
    if (NULL != obj) {
        obj->set_position(toGtkPositionType(position));
    }
}

void CFPopover::popup() {
    Gtk::Popover* obj = static_cast<Gtk::Popover*>(getObj());
    if (NULL != obj) {
        obj->popup();
    }
}

void CFPopover::popdown() {
    Gtk::Popover* obj = static_cast<Gtk::Popover*>(getObj());
    if (NULL != obj) {
        obj->popdown();
    }
}

CF_NAMESPACE_END
