// Copyright 2017, CDOS.
// All rights reserved.
//
// Author: CDOS Support Team <support_os@sari.ac.cn>
//
// A choice from multiple check buttons.
#include "Gui/CFRadioButton.h"
#include <gtkmm.h>

CF_NAMESPACE_BEGIN

CFRadioButton::~CFRadioButton() {
    setRealObject(NULL);
}

CFRadioButton::CFRadioButton()
    : CFCheckButton() {
    setRealObject(new Gtk::RadioButton());
}

CFRadioButton::CFRadioButton(const Glib::ustring& label, bool mnemonic)
    : CFCheckButton(label, mnemonic) {
    setRealObject(new Gtk::RadioButton(label, mnemonic));
}

void CFRadioButton::resetGroup() {
    Gtk::RadioButton* obj = static_cast<Gtk::RadioButton*>(getObj());
    if (NULL != obj) {
        obj->reset_group();
    }
}

void CFRadioButton::joinGroup(CFRadioButton& group_source) {
    Gtk::RadioButton* obj = static_cast<Gtk::RadioButton*>(getObj());
    Gtk::RadioButton* source
        = static_cast<Gtk::RadioButton*>(group_source.getObj());
    if (NULL != obj) {
        obj->join_group(*source);
    }
}

sigc::signal<void> CFRadioButton::signalGroupChanged() {
    return m_groupChangedSignal;
}

void CFRadioButton::onGroupChanged() {
    signalGroupChanged().emit();
}

void CFRadioButton::onRealObjectInit() {
    CFCheckButton::onRealObjectInit();
    Gtk::RadioButton* obj = static_cast<Gtk::RadioButton*>(getObj());
    if (NULL != obj) {
        obj->signal_group_changed().connect(
            sigc::mem_fun(*this, &CFRadioButton::onGroupChanged));
    }
}

void CFRadioButton::onRealObjectFinalize() {
}

CF_NAMESPACE_END
