// Copyright 2017, CDOS.
// All rights reserved.
//
// Author: CDOS Support Team <support_os@sari.ac.cn>
//
// The CFScrollbar widget is a horizontal or vertical scrollbar, depending on
// the value of the orientation property.
#include "Gui/CFScrollbar.h"
#include <gtkmm.h>
#include <glibmm/refptr.h>
#include "PrivCommon/CFConvertor.h"

CF_NAMESPACE_BEGIN

CFScrollbar::CFScrollbar() {
    setRealObject(new Gtk::Scrollbar());
}

CFScrollbar::~CFScrollbar() {
    setRealObject(NULL);
}

CFScrollbar::CFScrollbar(CFOrientation orientation) {
    static Glib::RefPtr<Gtk::Adjustment> adjustment
        = Gtk::Adjustment::create(50, 0, 100, 1, 10, 0);
    Gtk::Orientation orien = toGtkOrientation(orientation);
    setRealObject(new Gtk::Scrollbar(adjustment, orien));
}

CF_NAMESPACE_END
