#include "Gui/CFStackView.h"
#include "PrivDefines.h"
#include <gtkmm.h>
#include "CFConvertor.h"

CF_NAMESPACE_BEGIN

CFStackView::CFStackView()
    : CFContainer() {
    setRealObject(new Gtk::Stack());
}

CFStackView::~CFStackView() {
    setRealObject(NULL);
}

void CFStackView::add(CFWidget& child, const Glib::ustring& name) {
    Gtk::Stack* obj = static_cast<Gtk::Stack*>(getObj());
    Gtk::Widget* wobj = static_cast<Gtk::Widget*>(child.getObj());
    if (NULL != obj && NULL != wobj) {
        obj->add(*wobj, name);
    }
}

void CFStackView::add(CFWidget& child,
                      const Glib::ustring& name,
                      const Glib::ustring& title) {
    Gtk::Stack* obj = static_cast<Gtk::Stack*>(getObj());
    Gtk::Widget* wobj = static_cast<Gtk::Widget*>(child.getObj());
    if (NULL != obj && NULL != wobj) {
        obj->add(*wobj, name, title);
    }
}

void CFStackView::setVisibleChild(CFWidget& child) {
    Gtk::Stack* obj = static_cast<Gtk::Stack*>(getObj());
    Gtk::Widget* wobj = static_cast<Gtk::Widget*>(child.getObj());
    if (NULL != obj && NULL != wobj) {
        obj->set_visible_child(*wobj);
    }
}

CFWidget* CFStackView::getVisibleChild() {
    Gtk::Stack* obj = static_cast<Gtk::Stack*>(getObj());
    Gtk::Widget* child = NULL;
    if (NULL != obj) {
        child = obj->get_visible_child();
    }

    if (NULL != child) {
        return static_cast<CFWidget*>(getCFObject(child));
    }
    return NULL;
}

void CFStackView::setVisibleChild(const Glib::ustring& name) {
    Gtk::Stack* obj = static_cast<Gtk::Stack*>(getObj());
    if (NULL != obj) {
        obj->set_visible_child(name);
    }
}

void CFStackView::setVisibleChild(const Glib::ustring& name,
                                  CFStackTransitionType transition) {
    Gtk::Stack* obj = static_cast<Gtk::Stack*>(getObj());
    if (NULL != obj) {
        obj->set_visible_child(name, toGtkStackTransitionType(transition));
    }
}

Glib::ustring CFStackView::getVisibleChildName() {
    Gtk::Stack* obj = static_cast<Gtk::Stack*>(getObj());
    if (NULL != obj) {
        return obj->get_visible_child_name();
    }
    return "";
}

CF_NAMESPACE_END
