#include "Gui/CFWindow.h"
#include <gtkmm.h>
#include "CFConvertor.h"

CF_NAMESPACE_BEGIN

CFWindow::CFWindow(CFWindowType winType)
    : CFBin() {
    setRealObject(new Gtk::Window(toGtkWindowType(winType)));
}

CFWindow::~CFWindow() {
    setRealObject(NULL);
}

void CFWindow::setDefaultSize(int width, int height) {
    Gtk::Window* obj = static_cast<Gtk::Window*>(getObj());
    if (NULL != obj) {
        obj->set_default_size(width, height);
    }
}

void CFWindow::fullscreen() {
    Gtk::Window* obj = static_cast<Gtk::Window*>(getObj());
    if (NULL != obj) {
        obj->fullscreen();
    }
}

void CFWindow::setTypeHint(Gdk::WindowTypeHint hint) {
    Gtk::Window* obj = static_cast<Gtk::Window*>(getObj());
    if (NULL != obj) {
        obj->set_type_hint(hint);
    }
}

Gdk::WindowTypeHint CFWindow::getTypeHint() {
    Gtk::Window* obj = static_cast<Gtk::Window*>(getObj());
    if (NULL != obj) {
        return obj->get_type_hint();
    }
    return Gdk::WINDOW_TYPE_HINT_NORMAL;
}

CF_NAMESPACE_END
