#include "CFConvertor.h"

CF_NAMESPACE_BEGIN

Gtk::Align toGtkAlign(CFAlign align) {
    switch (align) {
    case CFALIGN_FILL:
        return Gtk::ALIGN_FILL;
    case CFALIGN_END:
        return Gtk::ALIGN_END;
    case CFALIGN_CENTER:
        return Gtk::ALIGN_CENTER;
    case CFALIGN_BASELINE:
        return Gtk::ALIGN_BASELINE;
    case CFALIGN_START:
    default:
        return Gtk::ALIGN_START;
    }
}

CFAlign toCdosAlign(Gtk::Align align) {
    switch (align) {
    case Gtk::ALIGN_FILL:
        return CFALIGN_FILL;
    case Gtk::ALIGN_END:
        return CFALIGN_END;
    case Gtk::ALIGN_CENTER:
        return CFALIGN_CENTER;
    case Gtk::ALIGN_BASELINE:
        return CFALIGN_BASELINE;
    case Gtk::ALIGN_START:
    default:
        return CFALIGN_START;
    }
}

Gtk::WindowType toGtkWindowType(CFWindowType windowType) {
    switch (windowType) {
    case CFWINDOW_POPUP:
        return Gtk::WINDOW_POPUP;
    case CFWINDOW_TOPLEVEL:
    default:
        return Gtk::WINDOW_TOPLEVEL;
    }
}

CFWindowType toCdosWindowType(Gtk::WindowType windowType) {
    switch (windowType) {
    case Gtk::WINDOW_POPUP:
        return CFWINDOW_POPUP;
    case Gtk::WINDOW_TOPLEVEL:
    default:
        return CFWINDOW_TOPLEVEL;
    }
}

Gtk::Orientation toGtkOrientation(CFOrientation orientation) {
    switch (orientation) {
    case CFORIENTATION_VERTICAL:
        return Gtk::ORIENTATION_VERTICAL;
    case CFORIENTATION_HORIZONTAL:
    default:
        return Gtk::ORIENTATION_HORIZONTAL;
    }
}

CFOrientation toCdosOrientation(Gtk::Orientation orientation) {
    switch (orientation) {
    case Gtk::ORIENTATION_VERTICAL:
        return CFORIENTATION_VERTICAL;
    case Gtk::ORIENTATION_HORIZONTAL:
    default:
        return CFORIENTATION_HORIZONTAL;
    }
}

Gtk::ReliefStyle toGtkReliefStyle(CFReliefStyle reliefStyle) {
    switch (reliefStyle) {
    case CFRELIEF_HALF:
        return Gtk::RELIEF_HALF;
    case CFRELIEF_NONE:
        return Gtk::RELIEF_NONE;
    case CFRELIEF_NORMAL:
    default:
        return Gtk::RELIEF_NORMAL;
    }
}

CFReliefStyle toCdosReliefStyle(Gtk::ReliefStyle reliefStyle) {
    switch (reliefStyle) {
    case Gtk::RELIEF_HALF:
        return CFRELIEF_HALF;
    case Gtk::RELIEF_NONE:
        return CFRELIEF_NONE;
    case Gtk::RELIEF_NORMAL:
    default:
        return CFRELIEF_NORMAL;
    }
}

Gtk::StackTransitionType toGtkStackTransitionType(CFStackTransitionType transition) {
    switch (transition) {
    case CFSTACK_TRANSITION_TYPE_CROSSFADE:
        return Gtk::STACK_TRANSITION_TYPE_CROSSFADE;
    case CFSTACK_TRANSITION_TYPE_SLIDE_RIGHT:
        return Gtk::STACK_TRANSITION_TYPE_SLIDE_RIGHT;
    case CFSTACK_TRANSITION_TYPE_SLIDE_LEFT:
        return Gtk::STACK_TRANSITION_TYPE_SLIDE_LEFT;
    case CFSTACK_TRANSITION_TYPE_SLIDE_UP:
        return Gtk::STACK_TRANSITION_TYPE_SLIDE_UP;
    case CFSTACK_TRANSITION_TYPE_SLIDE_DOWN:
        return Gtk::STACK_TRANSITION_TYPE_SLIDE_DOWN;
    case CFSTACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT:
        return Gtk::STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT;
    case CFSTACK_TRANSITION_TYPE_SLIDE_UP_DOWN:
        return Gtk::STACK_TRANSITION_TYPE_SLIDE_UP_DOWN;
    case CFSTACK_TRANSITION_TYPE_NONE:
    default:
        return Gtk::STACK_TRANSITION_TYPE_NONE;
    }
}

CFStackTransitionType toCdosStackTransitionType(Gtk::StackTransitionType transition) {
    switch (transition) {
    case Gtk::STACK_TRANSITION_TYPE_CROSSFADE:
        return CFSTACK_TRANSITION_TYPE_CROSSFADE;
    case Gtk::STACK_TRANSITION_TYPE_SLIDE_RIGHT:
        return CFSTACK_TRANSITION_TYPE_SLIDE_RIGHT;
    case Gtk::STACK_TRANSITION_TYPE_SLIDE_LEFT:
        return CFSTACK_TRANSITION_TYPE_SLIDE_LEFT;
    case Gtk::STACK_TRANSITION_TYPE_SLIDE_UP:
        return CFSTACK_TRANSITION_TYPE_SLIDE_UP;
    case Gtk::STACK_TRANSITION_TYPE_SLIDE_DOWN:
        return CFSTACK_TRANSITION_TYPE_SLIDE_DOWN;
    case Gtk::STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT:
        return CFSTACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT;
    case Gtk::STACK_TRANSITION_TYPE_SLIDE_UP_DOWN:
        return CFSTACK_TRANSITION_TYPE_SLIDE_UP_DOWN;
    case Gtk::STACK_TRANSITION_TYPE_NONE:
    default:
        return CFSTACK_TRANSITION_TYPE_NONE;
    }
}

Gtk::PositionType toGtkPositionType(CFPositionType posType) {
    switch (posType) {
    case CFPOS_LEFT:
        return Gtk::POS_LEFT;
    case CFPOS_RIGHT:
        return Gtk::POS_RIGHT;
    case CFPOS_BOTTOM:
        return Gtk::POS_BOTTOM;
    case CFPOS_TOP:
    default:
        return Gtk::POS_TOP;
    }
}

CFPositionType toCdosPositionType(Gtk::PositionType posType) {
    switch (posType) {
    case Gtk::POS_LEFT:
        return CFPOS_LEFT;
    case Gtk::POS_RIGHT:
        return CFPOS_RIGHT;
    case Gtk::POS_BOTTOM:
        return CFPOS_BOTTOM;
    case Gtk::POS_TOP:
    default:
        return CFPOS_TOP;
    }
}

Gtk::BuiltinIconSize toGtkBuiltinIconSize(CFBuiltinIconSize iconSize) {
    switch (iconSize) {
    case CFICON_SIZE_INVALID:
        return Gtk::ICON_SIZE_INVALID;
    case CFICON_SIZE_MENU:
        return Gtk::ICON_SIZE_MENU;
    case CFICON_SIZE_SMALL_TOOLBAR:
        return Gtk::ICON_SIZE_SMALL_TOOLBAR;
    case CFICON_SIZE_LARGE_TOOLBAR:
        return Gtk::ICON_SIZE_LARGE_TOOLBAR;
    case CFICON_SIZE_BUTTON:
        return Gtk::ICON_SIZE_BUTTON;
    case CFICON_SIZE_DND:
        return Gtk::ICON_SIZE_DND;
    case CFICON_SIZE_DIALOG:
        return Gtk::ICON_SIZE_DIALOG;
    default:
        return Gtk::ICON_SIZE_INVALID;
    }
}

CFBuiltinIconSize toCdosBuiltinIconSize(Gtk::BuiltinIconSize iconSize) {
    switch (iconSize) {
    case Gtk::ICON_SIZE_INVALID:
        return CFICON_SIZE_INVALID;
    case Gtk::ICON_SIZE_MENU:
        return CFICON_SIZE_MENU;
    case Gtk::ICON_SIZE_SMALL_TOOLBAR:
        return CFICON_SIZE_SMALL_TOOLBAR;
    case Gtk::ICON_SIZE_LARGE_TOOLBAR:
        return CFICON_SIZE_LARGE_TOOLBAR;
    case Gtk::ICON_SIZE_BUTTON:
        return CFICON_SIZE_BUTTON;
    case Gtk::ICON_SIZE_DND:
        return CFICON_SIZE_DND;
    case Gtk::ICON_SIZE_DIALOG:
        return CFICON_SIZE_DIALOG;
    default:
        return CFICON_SIZE_INVALID;
    }
}

Gtk::Justification toGtkJustification(CFJustification jtype) {
    switch (jtype) {
    case CFJUSTIFY_LEFT:
        return Gtk::JUSTIFY_LEFT;
    case CFJUSTIFY_RIGHT:
        return Gtk::JUSTIFY_RIGHT;
    case CFJUSTIFY_CENTER:
        return Gtk::JUSTIFY_CENTER;
    case CFJUSTIFY_FILL:
        return Gtk::JUSTIFY_FILL;
    default:
        return Gtk::JUSTIFY_LEFT;
    }
}

CFJustification toCdosJustification(Gtk::Justification jtype) {
    switch (jtype) {
    case Gtk::JUSTIFY_LEFT:
        return CFJUSTIFY_LEFT;
    case Gtk::JUSTIFY_RIGHT:
        return CFJUSTIFY_RIGHT;
    case Gtk::JUSTIFY_CENTER:
        return CFJUSTIFY_CENTER;
    case Gtk::JUSTIFY_FILL:
        return CFJUSTIFY_FILL;
    default:
        return CFJUSTIFY_LEFT;
    }
}

Gtk::CornerType toGtkCornerType(CFCornerType cornerType) {
    switch (cornerType) {
    case CFCORNER_TOP_LEFT:
        return Gtk::CORNER_TOP_LEFT;
    case CFCORNER_BOTTOM_LEFT:
        return Gtk::CORNER_BOTTOM_LEFT;
    case CFCORNER_TOP_RIGHT:
        return Gtk::CORNER_TOP_RIGHT;
    case CFCORNER_BOTTOM_RIGHT:
        return Gtk::CORNER_BOTTOM_RIGHT;
    default:
        return Gtk::CORNER_TOP_LEFT;
    }
}

CFCornerType toCdosCornerType(Gtk::CornerType cornerType) {
    switch (cornerType) {
    case Gtk::CORNER_TOP_LEFT:
        return CFCORNER_TOP_LEFT;
    case Gtk::CORNER_BOTTOM_LEFT:
        return CFCORNER_BOTTOM_LEFT;
    case Gtk::CORNER_TOP_RIGHT:
        return CFCORNER_TOP_LEFT;
    case Gtk::CORNER_BOTTOM_RIGHT:
        return CFCORNER_BOTTOM_LEFT;
    default:
        return CFCORNER_TOP_LEFT;
    }
}

Gtk::PolicyType toGtkPolicyType(CFPolicyType policyType) {
    switch (policyType) {
    case CFPOLICY_ALWAYS:
        return Gtk::POLICY_ALWAYS;
    case CFPOLICY_AUTOMATIC:
        return Gtk::POLICY_AUTOMATIC;
    case CFPOLICY_NEVER:
        return Gtk::POLICY_NEVER;
    case CFPOLICY_EXTERNAL:
        return Gtk::POLICY_EXTERNAL;
    default:
        return Gtk::POLICY_AUTOMATIC;
    }
}

CFPolicyType toCdosPolicyType(Gtk::PolicyType policyType) {
    switch (policyType) {
    case Gtk::POLICY_ALWAYS:
        return CFPOLICY_ALWAYS;
    case Gtk::POLICY_AUTOMATIC:
        return CFPOLICY_AUTOMATIC;
    case Gtk::POLICY_NEVER:
        return CFPOLICY_NEVER;
    case Gtk::POLICY_EXTERNAL:
        return CFPOLICY_EXTERNAL;
    default:
        return CFPOLICY_AUTOMATIC;
    }
}

Gtk::ShadowType toGtkShadowType(CFShadowType shadowType) {
    switch (shadowType) {
    case CFSHADOW_NONE:
        return Gtk::SHADOW_NONE;
    case CFSHADOW_IN:
        return Gtk::SHADOW_IN;
    case CFSHADOW_OUT:
        return Gtk::SHADOW_OUT;
    case CFSHADOW_ETCHED_IN:
        return Gtk::SHADOW_ETCHED_IN;
    case CFSHADOW_ETCHED_OUT:
        return Gtk::SHADOW_ETCHED_OUT;
    default:
        return Gtk::SHADOW_NONE;
    }
}

CFShadowType toCdosShadowType(Gtk::ShadowType shadowType) {
    switch (shadowType) {
    case Gtk::SHADOW_NONE:
        return CFSHADOW_NONE;
    case Gtk::SHADOW_IN:
        return CFSHADOW_IN;
    case Gtk::SHADOW_OUT:
        return CFSHADOW_OUT;
    case Gtk::SHADOW_ETCHED_IN:
        return CFSHADOW_ETCHED_IN;
    case Gtk::SHADOW_ETCHED_OUT:
        return CFSHADOW_ETCHED_OUT;
    default:
        return CFSHADOW_NONE;
    }
}

Gtk::PlacesOpenFlags toGtkPlacesOpenFlags(CFPlacesOpenFlags flags) {
    switch (flags) {
    case CFPLACES_OPEN_NORMAL:
        return Gtk::PLACES_OPEN_NORMAL;
    case CFPLACES_OPEN_NEW_TAB:
        return Gtk::PLACES_OPEN_NEW_TAB;
    case CFPLACES_OPEN_NEW_WINDOW:
        return Gtk::PLACES_OPEN_NEW_WINDOW;
    default:
        return Gtk::PLACES_OPEN_NORMAL;
    }
}

CFPlacesOpenFlags toCdosPlacesOpenFlags(Gtk::PlacesOpenFlags flags) {
    switch (flags) {
    case Gtk::PLACES_OPEN_NORMAL:
        return CFPLACES_OPEN_NORMAL;
    case Gtk::PLACES_OPEN_NEW_TAB:
        return CFPLACES_OPEN_NEW_TAB;
    case Gtk::PLACES_OPEN_NEW_WINDOW:
        return CFPLACES_OPEN_NEW_WINDOW;
    default:
        return CFPLACES_OPEN_NORMAL;
    }
}

Gtk::SelectionMode toGtkSelectionMode(CFSelectionMode mode) {
    switch (mode) {
    case CFSELECTION_NONE:
        return Gtk::SELECTION_NONE;
    case CFSELECTION_SINGLE:
        return Gtk::SELECTION_SINGLE;
    case CFSELECTION_BROWSE:
        return Gtk::SELECTION_BROWSE;
    case CFSELECTION_MULTIPLE:
        return Gtk::SELECTION_MULTIPLE;
    default:
        return Gtk::SELECTION_NONE;
    }
}

CFSelectionMode toCdosSelectionMode(Gtk::SelectionMode mode) {
    switch (mode) {
    case Gtk::SELECTION_NONE:
        return CFSELECTION_NONE;
    case Gtk::SELECTION_SINGLE:
        return CFSELECTION_SINGLE;
    case Gtk::SELECTION_BROWSE:
        return CFSELECTION_BROWSE;
    case Gtk::SELECTION_MULTIPLE:
        return CFSELECTION_MULTIPLE;
    default:
        return CFSELECTION_NONE;
    }
}

Gtk::PackDirection toGtkPackDirection(CFPackDirection direction) {
    switch (direction) {
    case CFPACK_DIRECTION_LTR:
        return Gtk::PACK_DIRECTION_LTR;
    case CFPACK_DIRECTION_RTL:
        return Gtk::PACK_DIRECTION_RTL;
    case CFPACK_DIRECTION_TTB:
        return Gtk::PACK_DIRECTION_TTB;
    case CFPACK_DIRECTION_BTT:
        return Gtk::PACK_DIRECTION_BTT;
    default:
        return Gtk::PACK_DIRECTION_RTL;
    }
}

CFPackDirection toCdosPackDirection(Gtk::PackDirection direction) {
    switch (direction) {
    case Gtk::PACK_DIRECTION_LTR:
        return CFPACK_DIRECTION_LTR;
    case Gtk::PACK_DIRECTION_RTL:
        return CFPACK_DIRECTION_RTL;
    case Gtk::PACK_DIRECTION_TTB:
        return CFPACK_DIRECTION_TTB;
    case Gtk::PACK_DIRECTION_BTT:
        return CFPACK_DIRECTION_BTT;
    default:
        return CFPACK_DIRECTION_LTR;
    }
}

Gtk::SensitivityType toGtkSensitivityType(CFSensitivityType type) {
    switch (type) {
    case CFSENSITIVITY_AUTO:
        return Gtk::SENSITIVITY_AUTO;
    case CFSENSITIVITY_ON:
        return Gtk::SENSITIVITY_ON;
    case CFSENSITIVITY_OFF:
        return Gtk::SENSITIVITY_OFF;
    default:
        return Gtk::SENSITIVITY_AUTO;
    }    
}

CFSensitivityType toCdosSensitivityType(Gtk::SensitivityType type) {
    switch (type) {
    case Gtk::SENSITIVITY_AUTO:
        return CFSENSITIVITY_AUTO;
    case Gtk::SENSITIVITY_ON:
        return CFSENSITIVITY_ON;
    case Gtk::SENSITIVITY_OFF:
        return CFSENSITIVITY_OFF;
    default:
        return CFSENSITIVITY_AUTO;
    }
}

// Enum Convert Template
// Gtk::SomeType toGtkSomeType(CFSomeType) {
//     switch (type) {
//     case CFSOME_TYPE_:
//         return Gtk::SOME_TYPE_;
//     case CFSOME_TYPE_:
//         return Gtk::SOME_TYPE_;
//     case CFSOME_TYPE_:
//         return Gtk::SOME_TYPE_;
//     default:
//         return Gtk::SOME_TYPE_;        
//     }
// }
//
// CFSomeType toCdosSomeType(Gtk::SomeType type) {
//     switch (type) {
//     case Gtk::SOME_TYPE_:
//         return CFSOME_TYPE_;
//     case Gtk::SOME_TYPE_:
//         return CFSOME_TYPE_;
//     case Gtk::SOME_TYPE_:
//         return CFSOME_TYPE_;
//     default:
//         return CFSOME_TYPE_;
//     }
// }

CF_NAMESPACE_END
